/*
 * Copyright (c) 1983 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Copyright (c) 1995  Kenji Arisawa. All right reserved.
 * License to freely use and distribute this software is hereby granted 
 * by the author, subject to the condition that this copyright notice 
 * remains intact.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY WARRANTIES.
 */

/*
 * tip+ 2.1:
 * Great reduction of old codes using table operations.
 * -Kenar-
 */


#ifndef lint
static char sccsid[] = "@(#)remote.c	5.4 (Berkeley) 9/2/88";
#endif /* not lint */

# include "tip.h"

char *rgetstr();

/* device type */
static struct {
	char *cap;
	char **pval;
} divcap[] = {
	{"at", &AT},
	{"dv", &DV},
	{"cm", &CM},
	{"cu", &CU},
	{"pn", &PN},
	{NULL, NULL}
};


/* negative boolean captions */
static struct{
	char *cap;
	int  id;
} nbcap[] = {
	{"nb", BEAUTIFY},
	{"nv", VERBOSE},
	{"nt", TAND},
	{NULL, 0}
};

getremcap(host) char *host;
{
	int stat;
	char tbuf[BUFSIZ];
	static char buf[BUFSIZ/2];
	char *bp = buf;
	char *r;
	int n,i;

	if ((stat = getent(tbuf,host,svalue(REMOTE))) <= 0) {
		if (DV ||
		    host[0] == '/' && access(DV = host, R_OK | W_OK) == 0) {
			CU = DV;
			svalue(HOST) = makstr(host);
			HW = 1;
			DU = 0;
			return;
		}
		fprintf(stderr, stat == 0 ?
			"tip: unknown host %s\n" :
			"tip: can't open host description file\n", host);
		exit(3);
	}

	for (n = 0; divcap[n].cap != NULL; n++){
		r = rgetstr(divcap[n].cap, &bp);
		if(r) *divcap[n].pval = makstr(r);
	}

	n = 0;
	for (n = 0; vname(n) != NULL; n++)
		if(vrname(n))
		switch(vtype(n)&TMASK){
		case STRING:
			r = rgetstr(vrname(n), &bp);
			if(r) svalue(n) = makstr(r);
			break;
		case NUMBER:
			if((i = rgetnum(vrname(n))) >= 0) nvalue(n) = i;
			break;
		case CHAR:
			r = rgetstr(vrname(n), &bp);
			if(r) cvalue(n) =  *r;
			break;
		case BOOL:
			if(rgetflag(vrname(n))) bvalue(n) = TRUE;
			break;
		default:;
		};
	
	for (n = 0; nbcap[n].cap != NULL; n++)
		if(rgetflag(nbcap[n].cap)) bvalue(nbcap[n].id) = FALSE;


	if (DU < 0)
		DU = 0;
	else
		DU = rgetflag("du");
	if (DV == NOSTR) {
		fprintf(stderr, "%s: missing device spec\n", host);
		exit(3);
	}
	if (DU && CU == NOSTR)
		CU = DV;
	if (DU && PN == NOSTR) {
		fprintf(stderr, "%s: missing phone number\n", host);
		exit(3);
	}

	/*
	 * This effectively eliminates the "hw" attribute
	 *   from the description file
	 */
	if (!HW)
		HW = (CU == NOSTR) || (DU && equal(DV, CU));
	svalue(HOST) = makstr(host);
}
