char *revision = "2.1"; /* tip+ revision */
#define PATCHLEVEL 0

/*
 * Copyright (c) 1983 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
 
/*
 * Modifications by Warren Tucker <wht%n4hgf.uucp@emory.mathcs.emory.edu>
 * for eight-bit transparent pass through and file transfer protocols
 * are unencumbered in any way. They are yours, ours, everybody's, nobody's.
 */
/*+:EDITS:*/
/*:05-08-1990-15:05-wht@n4hgf-rawthru */
/*:05-08-1990-15:00-wht@n4hgf-move tip.c original to tip-orig.c */

/*
 * Copyright (c) 1995  Kenji Arisawa. All right reserved.
 * License to freely use and distribute this software is hereby granted 
 * by the author, subject to the condition that this copyright notice 
 * remains intact.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY WARRANTIES.
 */
 
/*
 *  Modifications by Kenar(Kenji Arisawa)
 *	--- E-mail: arisawa@aichi-u.ac.jp
 *
 *  1993/09 (tip+ ver.1.00)
 *  1. Enrichment of login script.
 *  2. Japanese support.
 *
 *  1993/09 (tip+ ver.101)
 *  1. Bug fix in sort routine(login.c).
 *
 *  1993/10 (tip+ ver.102)
 *  1. cdelay, ldelay support
 *  2. linesync now available
 *  3. Bug fix in receiving JIS.
 *
 *	1995/12 (tip+ ver.2.0)
 *	1. Bug fix in login.c
 *	2. tip variable xfer
 *	3. tip variable keymap
 *	4. High speed modem support
 *	5. Renewed old codes in libacu and xfer.
 *
 *  1995/12 (tip+ ver.2.1)
 *  Reconstruction of previous dirty codes.
 *  CPU dependency are now removed. And...
 *  1. Changed the format and name of script file:
 *     %begin -> begin, %end -> end, and *.tipp -> *.tip+
 *  2. Changed the name of tip variable: loginscrip -> sysscript
 *  3. Removed tip variable halfduplex
 *  4. "[set] ?" displays only WRITE permitted variables.
 *  5. "[cd]" do nothing, and "[cd] ~" changes to HOME
 *  6. Shell meta-chars are abolished in file name input.
 *  7. Log file /usr/adm/aculog is displayed by "[set] all" command,
 *     and the log format is changed from tipx's to tip's.
 *  8. Environment variables REMOTE and PHONES are made ineffective
 *     in setuid execution.
 *  9. Guard against device lock when sending nothing to modem.
 * 10. Bus error and segmenation violation now disconnect dial line.
 * 11. Security holes in exec system call are removed.
 * 12. Tip+ now does not change to uucp.
 */


#ifndef lint
char copyright[] =
"@(#) Copyright(c) 1983 The Regents of the University of California.\n\
 All rights reserved.\n";
#endif /* not lint */

#ifndef lint
static char sccsid[] = "@(#)tip.c 5.8 (Berkeley) 9/2/88 (mod by wht@n4hgf)";
#endif /* not lint */

/*
 * tip - UNIX link to other systems
 *  tip [-psv] [-speed] system-name [data]
 * or
 *  cu phone-number [-s speed] [-l line] [-a acu]
 */
#include <sys/ioctl.h>
#include "tip.h"

char *login();
sigfunc_t intprompt();
sigfunc_t cleanup();
static sigfunc_t sigbus();
static sigfunc_t sigsegv();
static char *sname();
static void user_uid();
static void daemon_uid();


struct sgttyb	arg;		/* current mode of local terminal */
struct sgttyb	defarg;		/* initial mode of local terminal */
struct tchars	tchars;		/* current state of terminal */
struct tchars	defchars;	/* initial state of terminal */
static struct ltchars	ltchars;	/* current local characters of terminal */
static struct ltchars	deflchars;	/* initial local characters of terminal */
int	fildes[2];		/* file transfer synchronization channel */
int	repdes[2];		/* read process sychronization channel */
uid_t uid, euid;	/* real and effective user id's */
gid_t gid, egid;	/* real and effective group id's */
int	slip;			/* bring up SLIP on the line */
int	stoprompt;		/* for interrupting a prompt session */
int	cumode;			/* simulating the "cu" program */
char	ccc;			/* synchronization character */
int	odisc;				/* initial tty line discipline */
int	vflag;			/* print .tiprc initialization sequence */
int	pid;			/* pid of tipout */
int suidmode = FALSE;		/* Is set uid mode? (tip+) */
static char PNbuf[256];			/* This limits the size of a number */
static struct sgttyb ttyarg;
static int page;
static int disc = OTTYDISC;		/* tip normally runs this way */

/* tipx */
int rawthru = 0;
char *rawthru_msg = "\r\n--> raw tip:  3 ~ rapidly for ~ equivalent\r\n";
char *no_rawthru_msg = "\r\n--> normal tip: 1 ~ == ~\r\n";
extern char opened_tty[];


/*
 *	Baud rate mapping table
 *	- Kenar -
 */
typedef struct baudmap
{	char *name;
	int br;
	int bc;
} BAUD;
static BAUD bmap[] = 
{	/* see <sys/ttydev.h> for NeXT. - Kenar - */
	"0",	0,		B0,
	"50",	50,		B50,
	"75",	75,		B75,
	"110",	110,	B110,
	"134",	134,	B134,
	"150",	150,	B150,
	"200",	200,	B200,
	"300",	300,	B300,
	"600",	600,	B600,
	"1200",	1200,	B1200,
	"2400",	2400,	B2400,
	"4800",	4800,	B4800,
	"9600",	9600,	B9600,
	"14400",	14400,	B14400,
	"19200",	19200,	B19200,
	"28800",	28800,	B28800,
	"38400",	38400,	B38400,
	"43200",	43200,	B43200,
	"57600",	57600,	B57600,
	"HUP",	0,	B0,
	"EXTA",	0,	EXTA,
	"EXTB",	0,	EXTB,
	NULL,	-1,		-1
};



/*+-------------------------------------------------------------------------
	B_to_baud_rate(code) - convert CBAUD B_ code to baud rate string
--------------------------------------------------------------------------*/
char *B_to_baud_rate(code)
int code;
{	/* mod by Kenar */
	int n;
	for(n=0; bmap[n].name; n++)
		if(bmap[n].bc == code)
			return(bmap[n].name);
	return("-----");
}	/* end of B_to_baud_rate */


main(argc,argv)
char *argv[];
{
	char *system = NOSTR;
	char *data = NOSTR;
	int i;
	char *p;
	char sbuf[12];
	int scnextln;
	int baudcode;

	uid = getuid();
	gid = getgid();
	euid = geteuid();	/* should be root */
	egid = getegid();
	if(uid != euid) suidmode = TRUE;


	if(equal(sname(argv[0]),"cu"))
	{
		cumode = 1;
		cumain(argc,argv);
		goto cucommon;
	}

	if(argc < 2)
	{
		fprintf(stderr,
			"usage: %s [-psv] [-speed] [system-name] [data]\n",argv[0]);
		exit(1);
	}

	for(; argc > 1; argv++,argc--)
	{
		if(argv[1][0] != '-')
		{
			if(system)
				data = argv[1];
			else
				system = argv[1];
		}
		else switch(argv[1][1])
		{

		case 'p':
			page = TRUE;
			break;
		case 's':
			slip = TRUE;
			break;
		case 'v':
			vflag = TRUE;
			break;

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			nvalue(BAUDRATE) = atoi(&argv[1][1]);
			break;

		default:
			fprintf(stderr,"tip: %s, unknown option\n",argv[1]);
			break;
		}
	}
	if(!isatty(0) && !slip && !page)
	{
		fprintf(stderr,"tip: warning: input is not a tty\n");
	}

	if(system == NOSTR)
		goto notnumber;
	if(isalpha(*system))
		goto notnumber;
	/*
	 * System name is really a phone number...
	 * Copy the number then stomp on the original (in case the number
	 *	is private, we don't want 'ps' or 'w' to find it).
	 */
	if(strlen(system) > sizeof PNbuf - 1)
	{
		fprintf(stderr,"tip: phone number too long (max = %d bytes)\n",
		    sizeof PNbuf - 1);
		exit(1);
	}
	strncpy( PNbuf,system,sizeof PNbuf - 1 );
	for(p = system; *p; p++)
		*p = '\0';
	PN = PNbuf;
	(void)sprintf(sbuf,"tip%d",nvalue(BAUDRATE));
	system = sbuf;

notnumber:
	signal(SIGINT,cleanup);
	signal(SIGQUIT,cleanup);
	signal(SIGHUP,cleanup);
	signal(SIGTERM,cleanup);
	signal(SIGPIPE,cleanup);
	/* added by Kenar */
	signal(SIGBUS,sigbus);
	signal(SIGSEGV,sigsegv);
	

	/*
	 * Read environment variables before reading /etc/remote or REMOTE.
	 * -Kenar-
	 */
	for(i = 0; vname(i) != NULL; i++)
		if(vabbre(i) && isupper(*vabbre(i)) /* upper case abbre. is env. */
			&& (!suidmode || (suidmode && !(vaccess(i)&SECURE)))
			&& (p = getenv(vabbre(i))) != NULL)
			svalue(i) = p;
			
 	/*
	 * hunt: Find host entry hunting "/etc/remote" or REMOTE
	 * and initializes tip variables defined there.
	 * Hunt then opens the device.
	 * -Kenar-
	 */
	if(hunt(system) == NULL){
		printf("all ports busy\n");
		exit(3);
	}

	setbuf(stdout,NULL);

	/* checking slip parameters */
	if(slip == TRUE)
	{
		if(vndef(SLIPADDR))
		{
			printf("tip: local addr not set\n");
			uu_unlock(uucplock);
			exit(3);
		}
		if(vndef(SLIPDSTADDR))
		{
			printf("tip: destination addr not set\n");
			uu_unlock(uucplock);
			exit(3);
		}
		if(vndef(SLIPMASK))
		{
			printf("tip: slip netmask not set\n");
			uu_unlock(uucplock);
			exit(3);
		}
	}

cucommon:
	/*
	 * From here down the code is shared with
	 * the "cu" version of tip.
	 */
	 	 
	if((baudcode = speed(nvalue(BAUDRATE))) == 0)
	{
		printf("tip: bad baud rate %d\n",nvalue(BAUDRATE));
		(void)uu_unlock(uucplock);
		exit(3);
	}

	/*
	 * Hardwired connections require the
	 *  line speed set before they make any transmissions
	 *  (this is particularly true of things like a DF03-AC)
	 */

	if(HW)	ttysetup(baudcode);
	
	/* lconnect:
	 * connect to a device
	 * log is taken through lconnect
	 * lconnect must be executed in daemon mode to get correct user.
	 * -Kenar-
	 */
	if((p = lconnect()) != NULL)
	{
		printf("\07%s\n[EOT]\n",p);
		(void)uu_unlock(uucplock);
		exit(1);
	}
	
	if(!HW)	ttysetup(baudcode);
	
	/*
	 * make io functions ready prior to login
	 * -Kenar-
	 */
	setparity();	
	setpio(); /* set pread and pwrite. (Kenar) */

	/*
	 * SYSSCRIPT is a system script.
	 * -Kenar-
	 */
	if(vdef(SYSSCRIPT)){
		if(p = login(svalue(SYSSCRIPT))){
			disconnect(p);
			printf("\07%s\n[EOT]\n",p);
			(void)uu_unlock(uucplock);
			exit(1);
		}
	}

	/*
	 * Now that we have the logfile and the ACU open
	 *  return to the real uid and gid.  These things will
	 *  be closed on exit.  Swap real and effective uid's
	 *  so we can get the original permissions back
	 *  for removing the uucp lock.
	 */

	user_uid();	/* in the case of slip, we are now priviliged */

	/*  ---------------------------------------------------------
	 *                      W A R N I N G 
	 *  ---------------------------------------------------------
	 *  user_uid() executes setreuid(euid,uid) in it.
	 *  Then the process behaves as if it belongs to the user.
	 *  However NOTE that fork'ed and exec'ed processes inherit
	 *  both real and effective uids, so that these processes
	 *  have potentially a strong power.
	 *  It can be 'root' if it is executed in setuid mode of 'root'!
	 *  -Kenar-
	 *
	 *  Kenar says,
	 *    It will be the best for security to execute
	 *    setreuid(uid,uid)
	 *    here.
	 *    This action sweeps the potentiality of euid perfectly
	 *    from our process.
	 *    However we must return to euid to remove the locked file.
	 *    So we cannot execute setreuid(uid,uid) here.
	 *    
	 *    I would restrict user_uid() only here.
	 *    This is a good way for security.
	 *
	 *    Every exec process must be cleaned by
	 *    shell_uid()   i.e.  setreuid(uid,uid)
	 *    prior to execution.
	 *    It is a good manner to write down shell_uid() and execl(..)
	 *    in the same line, like that:
	 *        shell_uid(); execl(.......);
	 *    to detect dangerous mistake.
	 */


	/*
	 * tip+, tipx & tip messages
	 */
	{	printf("tip+ (%s)",revision);
		printf("        --- tipx(x1.21.01) mod by Kenar\r\n");
		puts("tipx (x1.21.01)   --- tip 4.3 mod by wht@n4hgf\r");
		printf("tip 4.3: ");
		puts(
		"Copyright (c) 1983 The Regents of the University of California.\r");
	}
		

	/*
	 * vinitialize:
	 * init tip variables using ".tiprc"
	 * -Kenar-
	 */
	 {	char file[256];
	 	FILE *f;
		strcpy(file, svalue(HOME));
		strcat(file, "/.tiprc");
		if ((f = fopen(file, "r")) != NULL)
		{	vinitialize(f,NULL);
			fclose(f);
		}
	}
	
	/*
	 * login:
	 * init tip variables using TIPP and then login
	 * parity and pio are set in this process
	 * -Kenar-
	 */
	{	char *TIPPDIR,*lscript;
		TIPPDIR = getenv("TIPP");
		if(TIPPDIR)
		{	char buf[BUFSIZ];
			strcpy(buf,TIPPDIR);
			strcat(buf,"/");
			strcat(buf,system);
			strcat(buf,".tip+");
			login(buf,"r");
		}
	}
	
	if(page)
	{
		i = sendpage(data);
		daemon_uid();
		(void)uu_unlock(uucplock);
		exit(i);
	}

	if(slip)
	{
		i = runslip();
		daemon_uid();
		(void)uu_unlock(uucplock);
		exit(i);
	}

	ioctl(0,TIOCGETP,(char *)&defarg);
	ioctl(0,TIOCGETC,(char *)&defchars);
	ioctl(0,TIOCGLTC,(char *)&deflchars);
	ioctl(0,TIOCGETD,(char *)&odisc);
	arg = defarg;
	
	/* tipx */
	arg.sg_flags = (rawthru?RAW:CBREAK);
	/* tip: ---
	arg.sg_flags = ANYP | CBREAK;
	*/

	tchars = defchars;
	tchars.t_intrc = tchars.t_quitc = -1;
	ltchars = deflchars;
	ltchars.t_suspc = ltchars.t_dsuspc = ltchars.t_flushc
	    = ltchars.t_lnextc = -1;
	raw();

	/*
	 * Everything's set up now:
	 *	connection established (hardwired or dialup)
	 *	line conditioned (baud rate, mode, etc.)
	 *	internal data structures (variables)
	 * so, fork one process for local side and one for remote.
	 */

	printf("\r\nconnected to %s\r\n",opened_tty);
	printf("line speed = %s, tandem = %s\r\n",
		B_to_baud_rate(ttyarg.sg_ospeed),
		(ttyarg.sg_flags & TANDEM) ? "yes" : "no");

	pipe(fildes);
	pipe(repdes);
	/* I removed
	 *    signal(SIGALRM,timeout);
	 * here, where timeout() is defined in 'cmds.c'.
	 * Note that setjmp(jmpbuf) have not be done.
	 * If this make an effect then tip+ may hang up.
	 * I made some corrections of 'cmds.c' so that the removal does not
	 * introduce new bugs.
	 * It seems to me 'signal(SIGALRM,timeout)' here is too easy way
	 * to remove time out error in file transmission.
	 * -Kenar-
	 */

	if(pid = fork())
		tipin();
	else
		tipout();
	/*NOTREACHED*/
}

sigfunc_t
cleanup()
{
	daemon_uid();
	(void)uu_unlock(uucplock);
	if(pid){
		(void) kill(pid,SIGTERM); /* kill child */
		unraw();
	}
	else if(odisc)
		ioctl(0,TIOCSETD,(char *)&odisc);
	exit(0);
}

sigfunc_t
sigbus()
{	puts("tip: buss error");
	cleanup();
}

sigfunc_t
sigsegv()
{	puts("tip: segmentation violation");
	cleanup();
}



/*
 * Muck with user ID's.  We are setuid to the owner of the lock
 * directory when we start.  user_uid() reverses real and effective
 * ID's after startup, to run with the user's permissions.
 * daemon_uid() switches back to the privileged uid for unlocking.
 * Finally, to avoid running a shell with the wrong real uid,
 * shell_uid() sets real and effective uid's to the user's real ID.
 */

static uid_t ceuid; /* current effective uid */

/*
 * shell_uid: switch perfectly to user's process
 * shell_uid must (and only) be executed prior to exec system call
 * like bellow.
 * shell_uid(); execl(....);
 * -Kenar-
 */
void shell_uid()
{
		setregid(gid,gid);
		setreuid(uid,uid);
}

/*
 * user_uid: switch to pseudo-user process.
 * Pseudo-user process looks like user process, but really it is not.
 * It has a power to be daemon.
 * -Kenar-
 */
static void user_uid()
{
	if(ceuid != uid)
	{
		setregid(egid,gid);
		setreuid(euid,uid);
		ceuid = uid;
	}
}

/*
 * daemon_uid: switch to daemon process.
 * This function makes effect only in pseudo-user process.
 * -Kenar-
 */
static void daemon_uid()
{
	if(ceuid != euid)
	{
		setreuid(uid,euid);
		setregid(gid,egid);
		ceuid = euid;
	}
}

/*
 * put the controlling keyboard into raw mode
 */
raw()
{
	ioctl(0,TIOCSETP,&arg);
	ioctl(0,TIOCSETC,&tchars);
	ioctl(0,TIOCSLTC,&ltchars);
	ioctl(0,TIOCSETD,(char *)&disc);
}


/*
 * return keyboard to normal mode
 */
unraw()
{
	ioctl(0,TIOCSETD,(char *)&odisc);
	ioctl(0,TIOCSETP,(char *)&defarg);
	ioctl(0,TIOCSETC,(char *)&defchars);
	ioctl(0,TIOCSLTC,(char *)&deflchars);
}

static jmp_buf promptbuf;

/*
 * Print string ``s'', then read a string
 *  in from the terminal.  Handles signals & allows use of
 *  normal erase and kill characters.
 */
prompt(s,p)
char *s;
register char *p;
{
	char *b = p;
	sigfunc_t(*oint)(),(*oquit)();

	stoprompt = 0;
	oint = signal(SIGINT,intprompt);
	oquit = signal(SIGQUIT,SIG_IGN);
	unraw();
	printf("%s",s);
	if(setjmp(promptbuf) == 0)
		while((*p = getchar()) != EOF && *p != '\n')
			p++;
	*p = '\0';

	raw();
	signal(SIGINT,oint);
	signal(SIGQUIT,oint);
	return(stoprompt || p == b);
}

/*
 * Interrupt service routine during prompting
 */
sigfunc_t
intprompt()
{

	signal(SIGINT,SIG_IGN);
	stoprompt = 1;
	printf("\r\n");
	longjmp(promptbuf,1);
}

/*
 * ****TIPIN   TIPIN****
 */
/*
 *	tipin() read stdin and send the codes to modem.
 *	- Kenar -
 */
tipin()
{
	char gch,bol = 1;
	int raise; /* current raise status */
	char buf[32];
	char *p;
		
	/*
	 * Kinda klugey here...
	 *   check for scripting being turned on from the .tiprc file,
	 *   but be careful about just using setscript(), as we may
	 *   send a SIGEMT before tipout has a chance to set up catching
	 *   it; so wait a second, then setscript()
	 *
	 * Kenar says,
	 *	 Tipx func setscript() is replaced by sigEMT(SCRIPT).
	 *	 see: cmds.c
	 */
	
	if(bvalue(SCRIPT)){
		sleep(1);
		sigEMT(SCRIPT);
	}
	
	raise = bvalue(RAISE);

	while(1){
		gch = getchar();
		/* ESCAPE should be the first to avoid masking of cvalue(ESCAPE) */
		if(gch == cvalue(ESCAPE) && bol){
				if(!(gch = escape())) continue;
		}
		bol = FALSE;
		if(!rawthru && !cumode){
			if(bvalue(RAISE)
				&& gch == cvalue(RAISECHAR)){
				raise = !raise;
				continue;
			}
			if(gch == cvalue(FORCE)) gch = getchar();
			if(raise && islower(gch)) gch = toupper(gch);
			if(vdef(KEYMAP) && gch == svalue(KEYMAP)[0])
				gch = svalue(KEYMAP)[2];
			bol = any(gch,svalue(EOL));
		}
		
		pwrite(&gch,1);
		if(bvalue(LOCALECHO)) putchar(gch);

		if(gch == '\r'){
			bol = TRUE;
			/* added by Kenar */
			if (nvalue(LDELAY) > 0) nap(nvalue(LDELAY));
			if(!rawthru && bvalue(LOCALECHO)) putchar('\n');
		}
		/* added by Kenar */
		if (nvalue(CDELAY) > 0) nap(nvalue(CDELAY));	}
}

/*
 * Escape handler --
 *  called on recognition of ``escapec'' at the beginning of a line
 */
escape()
{
	register char gch;
	register esctable_t *p;
	char c = cvalue(ESCAPE);
	extern esctable_t etable[];

	gch = (getchar()&0177);
	for(p = etable; p->e_char; p++)
		if(p->e_char == gch)
		{
			if((p->e_flags&PRIV) && uid)
				continue;
			(*p->e_func)(gch);
			return(0);
		}
	/* ESCAPE ESCAPE forces ESCAPE */
	if(c != gch)
		pwrite(&c,1);
	return(gch);
}

/* speed: converts baud rate to baud code */
speed(n)
int n;
{	/* Replaced by Kenar */
	int k;
	for(k = 0; bmap[k].br != -1; k++)
		if(bmap[k].br == n) return bmap[k].bc;
	return(0);
}

any(c,p)
register char c,*p;
{
	while(p && *p)
		if(*p++ == c)
			return(1);
	return(0);
}

size(s)
register char *s;
{
	register int i = 0;

	while(s && *s++)
		i++;
	return(i);
}

char *
interp(s)
register char *s;
{
	static char buf[256];
	register char *p = buf,c,*q;

	while(c = *s++)
	{
		for(q = "\nn\rr\tt\ff\033E\bb"; *q; q++)
			if(*q++ == c)
			{
				*p++ = '\\';
				*p++ = *q;
				goto next;
			}
		if(c < 040)
		{
			*p++ = '^';
			*p++ = c + 'A'-1;
		}
		else if(c == 0177)
		{
			*p++ = '^';
			*p++ = '?';
		}
		else
			*p++ = c;
next:
		;
	}
	*p = '\0';
	return(buf);
}

char *
ctrl(c)
char c;
{
	static char s[3];

	if(c < 040 || c == 0177)
	{
		s[0] = '^';
		s[1] = c == 0177 ? '?' : c+'A'-1;
		s[2] = '\0';
	}
	else 
	{
		s[0] = c;
		s[1] = '\0';
	}
	return(s);
}

/*
 * Help command
 */
help(c)
char c;
{
	register esctable_t *p;
	extern esctable_t etable[];

	for(p = etable; p->e_char; p++)
	{
		if((p->e_flags&PRIV) && uid)
			continue;
		printf("%2s",ctrl(cvalue(ESCAPE)));
		printf("%-2s %c   %s\r\n",ctrl(p->e_char),
		    p->e_flags&EXP ? '*': ' ',p->e_help);
	}
}

/*
 * Set up the "remote" tty's state
 */
ttysetup(speed)
int speed; /* speed is given by baud code - Kenar - */
{
	unsigned bits = LDECCTQ;

	ttyarg.sg_ispeed = ttyarg.sg_ospeed = speed;
	ttyarg.sg_flags = RAW;
	if(bvalue(TAND))
		ttyarg.sg_flags |= TANDEM;
	if(bvalue(DTRHUP))
	{
		ioctl(FD,TIOCSDTR,0);
		ioctl(FD,TIOCHPCL,0);
	}
	ioctl(FD,TIOCSETP,(char *)&ttyarg);
	ioctl(FD,TIOCLBIS,(char *)&bits);
}

/*
 * Return "simple" name from a file name,
 * strip leading directories.
 */
static char *
sname(s)
register char *s;
{
	register char *p = s;

	while(*s)
		if(*s++ == '/')
			p = s;
	return(p);
}


tip_abort(msg)
	char *msg;
{

	kill(pid, SIGTERM);
	daemon_uid();
	disconnect(msg);
	if (msg != NOSTR)
		printf("\r\n%s", msg);
	printf("\r\n[EOT]\r\n");
	(void)uu_unlock(uucplock);
	unraw();
	exit(0);
}
